# How to Mint a CIP-25 NFT
In this lesson, you will see how to mint an OG Cardano NFT. To mint a Cardano NFT, you will combine what you know about minting transactions, as seen in [Lesson 202.2](/modules/202/2022), and what you know about transaction metadata, as seen in [Lesson 203.1](/modules/203/2031).

NFT metadata must follow a specific format, as described in [Cardano Improvement Proposal 25](https://cips.cardano.org/cips/cip25/)

There are a lot of tools that will mint NFTs for you. The purpose of this lesson is to build your background knowledge about how such tools work.

<br />
---

## What is required to make a Cardano NFT?
- Metadata that follows the CIP25 Standard
- A minting script and its corresponding Policy ID
- The link to an image or media file

<br />
---

## What is NOT required to make a Cardano NFT?
- A specific kind of minting script. As long as you have a policy id, you can mint NFTs. (It's up to you to make sure they're "non-fungible"!)
- The minting script can be a native script or a Plutus script
- The minting script can require multiple signatures, but it does not have to
- The image can be hosted on decentralized storage, like [IPFS](https://docs.ipfs.tech/concepts/what-is-ipfs/) or [Arweave](https://www.arweave.org/). However, there is nothing in the NFT standard that says you can't use any other hosting service for your NFT. So for this example, we're not going to use decentralized storage. We're just going to use a picture that is hosted at [gimbalabs.com](https://gimbalabs.com/).


<br />
---

## Minting with the CIP 25 Standard
- In this lesson, you will see how to follow the CIP 25 Standard.
- In [Mastery Assignment 203.1](/modules/203/assignment2031), your task is to mint a specific NFT using a Plutus minting validator with specific rules.
- Then in Lessons [203.3](/modules/203/2033) and [203.4](/modules/203/2034), you will explore how the definition of NFTs on Cardano might be extended in the years to come.

### Here is an example of CIP-25 Metadata:

```JSON
{
  "721": {
    "<policy_id>": {
      "<asset_name>": {
        "name": "Gimbal G",
        "image": "https://www.gimbalabs.com/g.png",
        "mediaType": "image/png",
        "description": [
          "If you want to write more than 56 characters, you can ",
          "split a longer string into an array of strings, like ",
          "this!"
        ],
        "files": [
          {
            "mediaType": "image/png",
            "src": "https://www.gimbalabs.com/g.png"
          }
        ]
      }
    }
  }
}
```

#### From [CIP-25](https://cips.cardano.org/cips/cip25/):
<img src="/module203/metadata-files.png" alt="metadata-files" width="800" height="400" />

- This allows thumbnails & images to be different, for example.

<br />
---

## Minting NFTs with Mesh
You might have already noticed that the [Mesh Minting on Node.js tutorial](https://meshjs.dev/guides/minting-on-nodejs) (originally linked in Module 202) covers more than just minting tokens: it provides a full outline of how to mint NFTs.

<br />
---

## Minting NFTs with GameChanger

NFT minting is built into [GameChanger Wallet](https://preprod-wallet.gamechanger.finance/dashboard) - if you're interested, we bet that you can get it to work!

<br />
---

## Where should you store NFT images?
CIP 25 does not specify how images must be stored. In the example above, we are using IPFS. But the image could just as well be hosted at gimbalabs.com, like [this logo](https://www.gimbalabs.com/g.png), which is used in the metadata for your PPBL 2023 Token. Take a look at the metadata for your PPBL 2023 Token on [Cardanoscan PreProd, like in this example](https://preprod.cardanoscan.io/transaction/8d994ec37bb3de7f75d81755336ca2e3fc1d3176422e1ab15c3a8282f5394f37?tab=metadata):

<img src="/module203/ppbl2023-metadata.png" alt="ppbl2023-metadata" width="600" height="300" />


However, if the intention of someone minting an NFT is to make sure that an image is available "forever", in a decentralized way that does not rely on any individual actor, it is customary to use decentralized file storage, for example by using IPFS or Arweave.

### Interplanetary File System (IPFS) + Arweave
A deeper dive into decentralized storage is beyond the scope of this lesson, but you can explore on your own:

- [IPFS](https://ipfs.tech/) is a popular and reliable peer-to-peer storage network
- [NFT.Storage](https://nft.storage/) provides free storage for NFTs, on IPFS
- [Arweave](https://www.arweave.org/) is "like Bitcoin, but for data". The [Arweave documentation](https://www.arweave.org/use) is very good, and even though we will not cover Arweave directly in this course, we recommend taking at least a quick look at these docs.

<br />
---

## How can we "view" an NFT?

When you want to create an application for viewing NFTs, follow the steps outlined in [CIP-25](https://cips.cardano.org/cips/cip25/):

<img src="/module203/retrieve-metadata.png" alt="retrieve-metadata" width="600" height="300" />


The [PPBL NFT Gallery](/modules/203/nft-gallery) provides an example of how to view NFTs that are minted by following CIP-25. You can [view the source code here](https://gitlab.com/gimbalabs/ppbl-2023/ppbl-front-end-template-2023/-/blob/module-203-planning/src/components/course-modules/203/cardano/NFTGallery.tsx).

<br />
---

## What about minting a series of NFTs?
To mint a series with hundreds or thousands of NFTs, you will need to create a process for automating the steps above.

Beyond minting, there are additional challenges to minting an NFT series:
1. Making sure that no duplicates are minted
2. Handling high demand
3. Ensuring a fair launch

Many current projects use off-chain systems to solve for these challenges, but it is possible to design "serverless" solutions with smart contracts.

To start thinking about such system designs, read [this Twitter thread from @berry_ales](https://twitter.com/berry_ales/status/1651672819644657665).

If you want to, we can explore the concepts outlined in this thread (and in the accompanying [git repo](https://github.com/spacebudz/tokens/tree/main/nft/mass)), later in PPBL 2023.

<br />
---

## Ready to give it a try?
For now, let's mint your first NFT. In [Mastery Assignment 203.1](/modules/203/assignment2031), you will mint a PPBL 2023 NFT that uses a Plutus minting validator to ensure that only holders of the [PPBL 2023 Contributor Token](/modules/100/1004) can mint a PPBL 2023 NFT.

import MDXLessonLayout from "@/src/components/lms/Lesson/MDXLessonLayout.tsx";
export default ({ children }) => <MDXLessonLayout>{children}</MDXLessonLayout>
